// output.h

#include <string>
#include <iostream>

using namespace std;

// Output a String with Tab
void Emit(string s);

// Output string followed by new line
void WriteLn(string s);

// Output a String with Tab and CRLF
void EmitLn(string s);

// Generate a Unique Label
string* NewLabel();

// Post a Label To Output
void PostLabel(string L);

// Clear the primary register
int Clear();

// Negate the primary register
void Negate();

// Complement the primary register 
int NotIt(int Type);

// Load a constant into the primary register
void LoadConst(string c, int Type);

// Load a variable into the primary register
int LoadVar(string Name, int Type);

// Store primary to variable
void StoreVar(string Name, int Type);

// Convert a data item from one type to another
int Convert (int SrcType, int DstType);

// Push primary register on to stack
void Push(int Type);
  
// Add top of stack to primary
int PopAdd(int Type1, int Type2);

// Subtract primary from top of stack
int PopSub(int Type1, int Type2);

// Multiply top of stack by primary
int PopMul(int Type1, int Type2);

// Divide top of stack by primary
int PopDiv(int Type1, int Type2);

// AND top of stack with primary register
int PopAnd(int Type1, int Type2);

// OR top of stack with primary register
int PopOr(int Type1, int Type2);

// XOR top of stack with primary register
int PopXor(int Type1, int Type2);

// Compare top of stack with primary register
int PopCompare (int Type1, int Type2);

// Set D0 if compare was = 
void  SetEqual (int Type);

// Set D0 if compare was != 
void SetNotEqual(int Type);

// Set D0 if compare was > 
void SetGreater(int Type);

// Set D0 if compare was < 
void SetLess(int Type);

// Set D0 if compare was <= 
void SetLessOrEqual(int Type);

// Set D0 if compare was >= 
void SetGreaterOrEqual(int Type);

// Store primary to variable
void Store (string Name);

// Branch unconditional 
void Branch(string l);

// Branch False 
void BranchFalse(string l);

// Read variable into primary register
void ReadIt(string Name);

// Write variable from primary register
void WriteIt(int Type);

// Write header info
void Header();

// Write the prolog
void Prolog();

// Write the epilog
void Epilog();

// Allocate storage for variable
void Allocate (string Name, int Type, string Val);

// Call a procedure
void Call(string Name);

// Return from subroutine
void Return();

// Load a parameter into the primary register
void LoadParameter(int ParNum, int Type);

// Store a parameter from the primary register
void StoreParam(int n);

// Adjust the stack pointer upwards by N bytes
void CleanStack(int N);

// Write the prolog for a procedure
void ProcProlog(string N, int k);

// Write the epilog for a procedure
void ProcEpilog(string Name);
